#!/bin/sh
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

OOB_LOG_DIR=/var/log/oob/
OOB_LOG_FILE=${OOB_LOG_DIR}/oob.log

oob_log_dump()
{
	if [ "yes" != "$(/usr/syno/bin/synogetkeyvalue /etc.defaults/synoinfo.conf support_oob_ctl)" ]; then
		return 0
	fi

	if [ ! -d ${OOB_LOG_DIR} ]; then
		mkdir ${OOB_LOG_DIR}
	fi

	/bin/logrotate /etc/logrotate.d/oob
	if [ $? -ne 0 ]; then
		return 0
	fi

	if [ -f ${OOB_LOG_FILE} ]; then
		rm -f ${OOB_LOG_FILE}
	fi

	/usr/syno/bin/syno_oob_log_dump ${OOB_LOG_FILE}
}

# the file was touched in /etc/rc
if [ -f /tmp/.ImproperShutdown ]; then
	/usr/syno/bin/synologset1 sys warn 0x11100001
	/usr/syno/bin/synonotify ImproperShutdown
	rm -f /tmp/.ImproperShutdown
	oob_log_dump
fi
