#!/bin/sh
# Copyright (c) 2000-2014 Synology Inc. All rights reserved.

SYNO_FLAG_NO_LOG="/.nolog"
SYNO_FLAG_RESET_LOG_CONFIG="/.resetLogConfig"

RemoveLog() {
	rm /var/log/synolog/.SYNOACCOUNTDB*
	rm /var/log/synolog/synobackup.log
	rm /var/log/synolog/synoconn.log
	rm /var/log/synolog/synoindex.log
	rm /var/log/synolog/synonetbkp.log
	rm /var/log/synolog/synobackup_server.log
	rm /var/log/synolog/synosys.log
	rm /usr/syno/etc/preference/admin/dsmnotify
}

ResetXA() {
	# for XA factory reset
	local support_xa=$(/bin/get_key_value /etc.defaults/synoinfo.conf support_xa)
	if [ "$support_xa" != "yes" ] ; then
		return 0
	fi

	# workaround: synopkg uninstall HA pkg will fail due to this flag..
	rm -f /var/.NormalShutdown
	/var/packages/HighAvailability/target/sbin/synoha --factory-reset
	touch /var/.NormalShutdown

	# For md500 creation in first bootup
	rm -f /usr/syno/etc/root_backup.conf
}

RestoreLog() {
	rm -rf /var/log
	mkdir -m755 /var/log
	mkdir -m755 /var/log/healthtest
	mkdir -m750 /var/log/nginx
	mkdir -m755 /var/log/openvswitch
	mkdir -m755 /var/log/samba
	mkdir -m755 /var/log/upstart
}

RestoreConfig()
{
	# etc
	rm -f /etc/dhcpd/dhcpd.info
	rm -rf /etc/iscsi/nodes/*
	rm -rf /etc/iscsi/send_targets/*
	rm -rf /etc/iproute2/config/*
	rm -f /etc/iproute2/config/rt_tables
	rm -f /etc/nginx/nginx.conf
	cp -a /etc.defaults/hostname /etc/hostname
	cp -a /etc.defaults/hosts /etc/hosts
	cp -a /etc.defaults/passwd /etc/passwd
	rm -f /etc/passwd.cfgen.bkp
	cp -a /etc.defaults/shadow /etc/shadow
	rm -f /etc/shadow.cfgen.bkp
	cp -a /etc.defaults/synoinfo.conf /etc/synoinfo.conf
	cp -a /etc.defaults/synouser.conf /etc/synouser.conf
	rm -f /etc/synoautoblock.db
	rm -rf /etc/space/*
	cp -a /etc.defaults/samba /etc/
	cp -a /etc.defaults/TZ /etc/TZ
	rm -rf /etc/sysconfig
	cp -rf /etc.defaults/sysconfig /etc/
	rm -rf /etc/ssh
	cp -a /etc.defaults/ssh /etc/
	rm -f /etc/resolv.conf
	cp -a /etc.defaults/resolv.conf /etc/resolv.conf
	rm -f /etc/myds.conf
	cp -af /etc.defaults/synosyslog/notify.conf /etc/synosyslog/notify.conf
	cp -af /etc.defaults/synosyslog/notify.filter /etc/synosyslog/notify.filter
	rm -f /etc/snmp/snmpd.conf
	rm -f /etc/snmp/snmpd.conf.bak
	cp -a /etc.defaults/snmp/snmpd.conf /etc/snmp/snmpd.conf
	rm -f /etc/security/opasswd*

	# var
	rm -rf /var/cache/samba
	rm -rf /var/cache/syslog-ng/aa/*
	rm -rf /var/package/SnapshotReplication/etc/plan
	rm -f /var/package/SnapshotReplication/etc/replica.db
	rm -f /var/package/SnapshotReplication/etc/plan_sched_task.bak
	rm -f /var/package/SnapshotReplication/etc/snap_replica.db
	rm -f /var/lib/datascrubbing/datascrubbing.status

	# usr
	rm -rf /usr/local/synobtrfsreplicacore/
	rm -rf /usr/syno/etc/certificate
	rm -f /usr/syno/etc/.disk_dp_update_time
	rm -f /usr/syno/etc/datasrubbing.conf
	rm -f /usr/syno/etc/disk.conf
	rm -f /usr/syno/etc/disk_health_record_time
	rm -f /usr/syno/etc/disk_health_infomation_record_time
	rm -f /usr/syno/etc/esynoscheduler/esynoscheduler.db
	rm -f /usr/syno/etc/flashcache.conf
	rm -f /usr/syno/etc/indexdb/notification/notification_filter.settings
	rm -f /usr/syno/etc/iscsi_lun.conf
	rm -f /usr/syno/etc/iscsi_target.conf
	rm -rf /usr/syno/etc/private/session
	rm -rf /usr/syno/etc/preference/*
	rm -f /usr/syno/etc/mount.conf
	rm -f /usr/syno/etc/raid_setting.conf
	rm -f /usr/syno/etc/scheduled_tasks
	rm -rf /usr/syno/etc/scheduled_tasks_backup
	rm -f /usr/syno/etc/sched_status.sqlite
	rm -f /usr/syno/etc/security-profile/tls-profile/service/dsm.conf
	rm -rf /usr/syno/etc/sed_keymanager
	rm -rf /usr/syno/etc/.sed_ak
	rm -f /usr/syno/etc/space_resource
	rm -rf /usr/syno/etc/synobtrfsreplica/
	rm -f /usr/syno/etc/synocrond.config
	rm -f /usr/syno/etc/synodr/node.db
	rm -f /usr/syno/etc/synodr/node.info
	rm -f /usr/syno/etc/synoperfevent.conf
	rm -rf /usr/syno/etc/synorelayd/misc.conf
	rm -rf /usr/syno/etc/synoservice.override
	rm -f /usr/syno/etc/synosyslog.db
	rm -f /usr/syno/etc/synotuned/config
	rm -f /usr/syno/etc/systemraid.conf
	rm -f /usr/syno/etc/volume.conf
	cp -a /usr/syno/etc.defaults/strongpassword.conf /usr/syno/etc/strongpassword.conf
	cp -a /usr/syno/etc.defaults/www/DSM.json /usr/syno/etc/www/DSM.json
	rm -rf /usr/syno/etc/firewall.d
	cp -a /usr/syno/etc.defaults/firewall.d /usr/syno/etc/
	rm -f /usr/syno/etc/datascrubbing.conf
	cp -af /usr/syno/etc.defaults/synosms.conf /usr/syno/etc/synosms.conf
	cp -af /usr/syno/etc.defaults/synosmtp.conf /usr/syno/etc/synosmtp.conf
	rm -rf /usr/syno/etc/synoretention
	rm -f /usr/syno/etc/iscsi_setting.conf
	rm -f /usr/syno/etc/isns.conf
	rm -rf /usr/syno/etc/synoretention/Lun#/
	rm -rf /usr/syno/etc/synonetworkbkp/*
	cp -af /usr/syno/etc.defaults/synosyslog/client.conf /usr/syno/etc/synosyslog/client.conf
	rm -f /usr/syno/etc/synosyslog/client_keys/*
	rm -f /usr/syno/etc/notification/notification_filter.settings
	rm -f /usr/syno/etc/notification/mails

	# remote_config_backup
	rm -rf /remote_config_backup/lsyncd/*

	# Factory config
	rm -f /.start_manutild
}

if [ -f "${SYNO_FLAG_NO_LOG}" ]; then
	RemoveLog
	rm ${SYNO_FLAG_NO_LOG}
fi

if [ -f "${SYNO_FLAG_RESET_LOG_CONFIG}" ]; then
	ResetXA
	RestoreLog
	RestoreConfig
	rm ${SYNO_FLAG_RESET_LOG_CONFIG}
fi
