#!/usr/bin/python
#! coding: utf-8
# Copyright (c) 2000-2018 Synology Inc. All rights reserved.

from utils import *

class RuleDictResult(DictResult):
    _non_comp_version = [DEFAULT_NON_COMP_VERSION]
    _group = [GROUP_HOME, GROUP_COMPANY]
    _category = CATEGORY_SYSTEM_CHECK
    _severity = LEVEL_WARNING
    _strId = 'rule_xmrig_check'

    """ please implement the following functions """
    def getStatus(self):
        with SynoCriticalSection() as cs:
            ret = execWebAPI('SYNO.Core.Package', 'list', 1)

            pkg = ret['data']['packages'] if ret['success'] else []
            pkg = [_ for _ in pkg if _['id'] == 'xmrig']

            self._pass_ = pkg == []

        return SZ_PASS if self._pass_ else SZ_FAIL

    def getMethod(self):
        method = {
            METHOD_ACTION: METHOD_ACTION_FIXME,
        }
        return method

    def getAction(self):
        if self._pass_:
            return {}
        else:
            action = {
                ACTION_STR_KEY : 'action',
            }
            return action

    def fixmeAction(self):
        with SynoCriticalSection() as cs:
            ret = execWebAPI('SYNO.Core.Package.Uninstallation', 'uninstall', 1, id='xmrig')
        return ret['success']
